#include <curses.h>
#include <signal.h>
#include <string.h>
#include <sys/ioctl.h>
#include "ekran.c"
#include "ramki.h"
#include "snifer.c"
#include "sender.c"
#include "snifuj.c"
#include "senduj.c"
#include "itoa.c"


int pokaz_info() {
    unsigned char napis[51];

    pokaz_pole(2,2,20,4,60,' ');
    strcpy(napis,"IPTOOLS v0.8b");
    pokaz_napis(4,3,napis,60);
    strcpy(napis,"(C) Piotr Pawlus");
    pokaz_napis(4,4,napis,60);  
    strcpy(napis,"INFO");
    pokaz_okno(2,8,20,8,0,&napis,0);
    strcpy(napis,"Packets=");
    pokaz_napis(3,9,napis,0);
    strcpy(napis,"IP=");
    pokaz_napis(3,10,napis,0);
    strcpy(napis,"ARP=");
    pokaz_napis(3,11,napis,0);
    strcpy(napis,"Other=");
    pokaz_napis(3,12,napis,0);
    pokaz_pole(3,13,18,1,0,'-');
    strcpy(napis,"Device=lo");
    pokaz_napis(3,14,napis,0);
    return 0;    
}

int ustaw_filtr(int *dane) {
    char napis[21];
    int i;
    char id[21];
    char ip[21];

    strcpy(dane,"0 0");
    strcpy(napis,"");
    if (pisz_tekst(8,19,20,0,&napis,2)==10) {
	for (i=0;i<strlen(napis);i++) if (napis[i]==' ') break;
	if ((i!=strlen(napis)) && (strlen(napis)!=0)) {
	    strncpy(id,napis,i);
	    id[i]='\0';
	    strcpy(ip,napis+i+1);
	    i=0;
	    if (strcmp(id,"IP")==0) i=1;
	    if (strcmp(id,"IPS")==0) i=2;
	    if (strcmp(id,"IPD")==0) i=3;
    	    sprintf(dane,"%i %i",i,inet_addr(ip));
	    pokaz_napis(8,19,napis,0);
	}
    }
    return 0;
}

int kopiuj_pakiet(int iledanych,int *dane) {
    struct ethernetII b_ethII;

    memcpy(&b_ethII,dane,sizeof(struct ethernetII));    
    switch (ntohs(b_ethII.id)) {
	case 0x0800: memcpy(&daneip,dane,iledanych); 
		     iledaneip=iledanych;
		     break;
	case 0x0806: memcpy(&danearp,dane,iledanych); 
		     iledanearp=iledanych;
	             break;
    }
    return 0;
}

int wczytaj_stats(int *nazwapliku) {
    FILE *numerpliku;
    struct dane_stats b_stats;
    unsigned char napis[15];

    bzero(&b_stats,sizeof(struct dane_stats));
    if ((numerpliku=fopen(nazwapliku,"r"))>0) {
	fseek(numerpliku,0,SEEK_SET);
	fread(&b_stats,sizeof(struct dane_stats),1,numerpliku);
	fclose(numerpliku);
    }
    bzero(&napis,sizeof(napis));
    strcpy(napis,itoa(b_stats.pakiety));
    strcat(napis,wypel_znakiem(10-strlen(napis)));
    pokaz_napis(11,9,napis,0);
    bzero(&napis,sizeof(napis));
    strcpy(napis,itoa(b_stats.ip));
    strcat(napis,wypel_znakiem(10-strlen(napis)));
    pokaz_napis(6,10,napis,0);
    bzero(&napis,sizeof(napis));
    strcpy(napis,itoa(b_stats.arp));
    strcat(napis,wypel_znakiem(10-strlen(napis)));
    pokaz_napis(7,11,napis,0);
    bzero(&napis,sizeof(napis));
    strcpy(napis,itoa(b_stats.other));
    strcat(napis,wypel_znakiem(10-strlen(napis)));
    pokaz_napis(9,12,napis,0);
    return 0;
}

int getinterfaceNAME(int ifindex,int *ifname) {
    struct ifreq ifr;
    int mojsock;
    
    ifr.ifr_ifindex=ifindex;
    if ((mojsock=socket(AF_PACKET,SOCK_RAW,htons(ETH_P_ALL)))<0) return -1;
    if (ioctl(mojsock,SIOCGIFNAME,&ifr)<0) return -1;
    strcpy(ifname,ifr.ifr_name);
    close(mojsock);
    return 0;
}

int wybor_interface(int ethx) {
    FILE *plik1;
    char nplik1[20]="ekran7.swp";
    char napisy[20][20];
    char napis[20];
    int i,j=0;
    int interface=ethx;

    strcpy(napisy[0],"");
    for (i=1;i<10;i++) {
	if (getinterfaceNAME(i,&napis)!=0) break;
	j++;
	strcpy(napisy[j],napis);
    }
    plik1=fopen(nplik1,"w");
    putwin(stdscr,plik1);
    fclose(plik1);
    if (j>0) i=pokaz_menu(10,14,j,napisy,0,0);
    plik1=fopen(nplik1,"r");
    stdscr=getwin(plik1);
    fclose(plik1);
    remove(&nplik1);
    if ((i>0) && (j>0)) {
	strcpy(napis,napisy[i]);
	strcat(napis,wypel_znakiem(10-strlen(napis)));
	pokaz_napis(10,14,napis,0);
	interface=i;
    }
    wrefresh(stdscr);
    return interface;
}

int pokaz_menu_glowne(int pole) {
    unsigned char napis[51];
    int kolor=0;

    kolor=0;
    if (pole==0) kolor=2;
    strcpy(napis," IP ");
    pokaz_napis(25,2,napis,kolor);
    kolor=0;
    if (pole==1) kolor=2;
    strcpy(napis," ARP ");
    pokaz_napis(29,2,napis,kolor);
    pokaz_okno(25,3,52,12,0,0,0);  
    strcpy(napis,"| 'S'=send  'E'=edit  'D'=device |");
    pokaz_napis(27,14,napis,0);
    switch (pole) {
	case 0x00: rysuj_menu_ip(); break;
	case 0x01: rysuj_menu_arp(); break;
    }
    return 0;
}

int main(int ile_param,char *param[]) {
    int i,pidpotomka=0;
    char klawisz=0;
    char nazwapliku1[10]="_ethx";
    char nazwapliku2[10]="_stat";
    unsigned char pokaz[3];
    unsigned char filtr[15]="0 0";
    long int pozycja=0;
    long int pozycja2=0;
    int ethx=1;
    int ktoralinia=0;
    int akt=0,kolor;
    int dalej=0;
    int koniec=0;
    unsigned int pole=0;

    remove(&nazwapliku1);
    remove(&nazwapliku2);
    initscr();
    ustaw_terminal();
    ustaw_pary();
    cls();
    bzero(&linie,sizeof(linie));
    bzero(&daneip,sizeof(daneip));
    bzero(&danearp,sizeof(danearp));    
    pokaz_okno_snifera(0,20);
    ustaw_dowyslania();
    pokaz_menu_glowne(0);
    pokaz_info();
    keypad(stdscr,TRUE);
    nodelay(stdscr,TRUE);
    do {
	bzero(&pokaz,sizeof(pokaz));
	klawisz=getch();
	if (klawisz=='R') {
	    pozycja=0;
	    pozycja2=0;
	    ktoralinia=0;
	    akt=0;
	    dalej=0;
	    pokaz[1]=1;
	    if (pidpotomka==0) {
		if ((pidpotomka=fork())==0) {
		    snifuj(&nazwapliku1,&nazwapliku2,&filtr);
		    return 0;
		}
	    }
	    else {
		kill(pidpotomka,SIGKILL);
		remove(&nazwapliku1);
		remove(&nazwapliku2);
		pidpotomka=0;
	    }
	}
	if ((klawisz==4) && (pole>0)) {
	    pole--;
	    pokaz[2]=1;
	}
	if ((klawisz==5) && (pole<1)) {
	    pole++;
	    pokaz[2]=1;
	}
	if ((klawisz==2) && (akt==(max_lini_danych-1)) && (koniec==1)) {
	    pozycja2+=((linie[0].iledanych)+4);
	    pozycja=pozycja2;
	    ktoralinia=0;
	    dalej=0;
	}
	if ((klawisz==3) && (akt==0) && (linie[0].upiledanych>0)) {
	    pozycja2-=((linie[0].upiledanych)+4);
	    pozycja=pozycja2;
	    ktoralinia=0;
	    dalej=1;
	}
	if ((klawisz==2) && (akt<(ktoralinia-1))) {
	    akt++;
	    pokaz[0]=1;
	    dalej=1;
	}
	if ((klawisz==3) && (akt>0)) {
	    akt--;
	    pokaz[0]=1;
	    dalej=1;
	}
	if (klawisz=='E') {
	    switch (pole) {
		case 0x00: edycja_ip(); break;
		case 0x01: edycja_arp(); break;
	    }
	    pokaz[2]=1;
	}
	if (klawisz=='S') {
	    switch (pole) {
		case 0x00: senduj(iledaneip,&daneip,ethx); break;
		case 0x01: senduj(iledanearp,&danearp,ethx); break;
	    }
	}
	if (klawisz=='K') {
	    kopiuj_pakiet(linie[akt].iledanych,&linie[akt].danepola);
	    pokaz[2]=1;
	}
	if (klawisz=='F') ustaw_filtr(&filtr);
	if (klawisz=='D') ethx=wybor_interface(ethx);
	if ((klawisz=='V') && (ktoralinia>0)) podglad_pakietu(akt);
	koniec=0;	
	if (wczytaj_linie_z_pliku(&nazwapliku1,pozycja,ktoralinia)==1) {
	    koniec=1;
	    if (ktoralinia<max_lini_danych) {
		pozycja+=((linie[ktoralinia].iledanych)+4);
		ktoralinia++;
		pokaz[0]=1;
	    }
	    else {
		if (dalej==0) {
	    	    pozycja2+=((linie[0].iledanych)+4);
	    	    pozycja=pozycja2;
	    	    ktoralinia=0;
	    	    pokaz[0]=0;
		}
	    }
	}
	wczytaj_stats(&nazwapliku2);
	if (pokaz[2]==1) pokaz_menu_glowne(pole);
	if (pokaz[1]==1) pokaz_pole(1,21,78,max_lini_danych,0,' ');
	if (pokaz[0]==1) {
	    for (i=0;i<ktoralinia;i++) {
		kolor=0;
		if (i==akt) kolor=2;
		pokaz_pole_danych(1,21+i,&linie[i].danepola,linie[i].iledanych,kolor);
	    }
	}
    } while (!(klawisz=='X'));
    if (pidpotomka!=0) kill(pidpotomka,SIGKILL);
    cls();
    endwin();
    return 0;
}
