#define max_lini_danych 8

struct pole_lini {
    unsigned short upiledanych;
    unsigned short iledanych;
    char danepola[max_ethernetII];
};

static struct pole_lini linie[(max_lini_danych+1)];

int wczytaj_linie_z_pliku(int *nazwapliku,long int pozycja,int ilelini) {
    FILE *numerpliku;
    int koniec=0;
    long int wynik;

    if ((numerpliku=fopen(nazwapliku,"r"))==NULL) return -1;
    fseek(numerpliku,0,SEEK_END);
    wynik=ftell(numerpliku);
    if (pozycja<wynik) {
        fseek(numerpliku,pozycja,SEEK_SET);
	fread(&linie[ilelini].upiledanych,2,1,numerpliku);
	fread(&linie[ilelini].iledanych,2,1,numerpliku);
	if (linie[ilelini].iledanych>0) {
	    fread(&linie[ilelini].danepola,linie[ilelini].iledanych,1,numerpliku);
	    koniec=1;
	}
    }
    fclose(numerpliku);
    return koniec;
}

int pokaz_okno_snifera(int x,int y) {
    unsigned char napis[81];

    strcpy(napis,"filter=");
    pokaz_napis(x+1,y-1,napis,0);
    pokaz_okno(x,y,80,(max_lini_danych+2),0,0,0);
    strcpy(napis," size macd         macs         pro          ips             ipd                ");
    pokaz_napis(x,y,napis,7);
    strcpy(napis,"| 'R'=start/stop  'F'=filter  'V'=view  'K'=copy  'X'=exit |");
    pokaz_napis(x+2,y+(max_lini_danych+1),napis,0);
}

int pokaz_pole_danych(int x,int y,int *bufor,int ileb,int kolor) {
    struct ethernetII b_ethII;
    struct ramka_ipv4 b_ramka_ipv4;
    struct ramka_arp b_ramka_arp;
    int i,b_offset;
    unsigned char napis[81];

    strcpy(napis,"");    
    if (ileb>0) {
	// wielkosc
	strcpy(napis,itoa(ileb));
	if (strlen(napis)<4) strcat(napis,wypel_znakiem(4-strlen(napis)));
	strcat(napis," ");
	// MAC dest
	memcpy(&b_ethII,bufor,sizeof(struct ethernetII));
	for (i=0;i<=5;i++) strcat(napis,itoa_hex_byte(b_ethII.macprzeznaczenia[i]));
	strcat(napis," ");
	// MAC source
	for (i=0;i<=5;i++) strcat(napis,itoa_hex_byte(b_ethII.maczrodla[i]));
	strcat(napis," ");
	// numer ramki
	strcat(napis,itoa_hex_word(ntohs(b_ethII.id)));
	// ip source oraz ip dest
	b_offset=bufor;
	b_offset+=sizeof(struct ethernetII);
	switch (ntohs(b_ethII.id)) {
    	    case 0x0800:memcpy(&b_ramka_ipv4,b_offset,sizeof(struct ramka_ipv4));
			strcat(napis,"(IP) ");
			if (strlen(napis)<44) strcat(napis,wypel_znakiem(44-strlen(napis)));
			strcat(napis,inet_ntoa(b_ramka_ipv4.ipzrodla));
			if (strlen(napis)<60) strcat(napis,wypel_znakiem(60-strlen(napis)));
			strcat(napis,inet_ntoa(b_ramka_ipv4.ipprzeznaczenia));
			break;
	    case 0x0806:memcpy(&b_ramka_arp,b_offset,sizeof(struct ramka_arp));
			strcat(napis,"(ARP) ");
			if (strlen(napis)<44) strcat(napis,wypel_znakiem(44-strlen(napis)));
			strcat(napis,itoa_ip(&b_ramka_arp.ipzrodla));
			if (strlen(napis)<60) strcat(napis,wypel_znakiem(60-strlen(napis)));
			strcat(napis,itoa_ip(&b_ramka_arp.ipprzeznaczenia));
			break;
	}
    }
    // pokaz cala linijke
    if (strlen(napis)<78) strcat(napis,wypel_znakiem(78-strlen(napis)));
    pokaz_napis(x,y,&napis,kolor);
    return 0;
}

int podglad_danych_pakietu (int x,int y,int y1,int *dane,int iledanych) {
    FILE *plik1;
    char nplik1[20]="ekran2.swp";
    char klawisz=0;
    unsigned char napis[51];
    unsigned int i,j,z=0;
    unsigned char znak;
    unsigned int d_offset;
    
    if (iledanych>0) {
        plik1=fopen(nplik1,"w");
	putwin(stdscr,plik1);
	fclose(plik1);
	strcpy(napis,"DATA");
	pokaz_okno(x,y,71,(y1+2),0,&napis,0);
	strcpy(napis,"| 'Q'=quit |");
	pokaz_napis(x+2,y+(y1+1),napis,0);
	for (j=0;j<y1;j++) {
	    for (i=0;i<16;i++) {
		d_offset=dane;
		d_offset+=z;
		z++;
		if (z>iledanych) {
		    j=y1;
		    break;
		}
		memcpy(&znak,d_offset,1);
		pokaz_napis(x+2+(i*3),y+1+j,itoa_hex_byte(znak),0);
		if (znak<32) znak='.';
		pokaz_znak(x+53+i,y+1+j,znak,0);
	    }
	}
	keypad(stdscr,TRUE);
	nodelay(stdscr,TRUE);
	do {
	    klawisz=getch();
	} while (!(klawisz=='Q'));
	plik1=fopen(nplik1,"r");
	stdscr=getwin(plik1);
	fclose(plik1);
	remove(&nplik1);
	wrefresh(stdscr);
    }
    return 0;
}

int podglad_pakietu(int linia) {
    FILE *plik1;
    char nplik1[20]="ekran1.swp";
    char klawisz=0;
    unsigned char napis[51];
    struct ethernetII b_ethII;
    struct ramka_ipv4 b_ipv4;
    struct protokol_icmp b_pro_icmp;
    struct protokol_tcp b_pro_tcp;
    struct protokol_udp b_pro_udp;
    struct ramka_arp b_arp;
    unsigned int i,b_offset;
    unsigned char danepakietu[1518];
    unsigned int iledanychpakietu=0;
    unsigned int b2_offset;
    
    plik1=fopen(nplik1,"w");
    putwin(stdscr,plik1);
    fclose(plik1);
    pokaz_okno(2,1,76,18,0,0,0);
    pokaz_pole(15,2,1,16,0,'|');
    strcpy(napis,"PACKET");
    pokaz_napis(4,1,napis,0);
    strcpy(napis,"DATA");
    pokaz_napis(17,1,napis,0);
    strcpy(napis,"| 'Q'=quit |");
    pokaz_napis(4,18,napis,0);
    strcpy(napis,"EthernetII");
    pokaz_napis(4,3,napis,0);
    strcpy(napis,"MACd=              MACs=              Pro=");
    pokaz_napis(17,3,napis,0);
    memcpy(&b_ethII,&linie[linia].danepola,sizeof(struct ethernetII));
    strcpy(napis,"");
    for (i=0;i<=5;i++) strcat(napis,itoa_hex_byte(b_ethII.macprzeznaczenia[i]));
    pokaz_napis(22,3,napis,0);
    strcpy(napis,"");
    for (i=0;i<=5;i++) strcat(napis,itoa_hex_byte(b_ethII.maczrodla[i]));
    pokaz_napis(41,3,napis,0);
    strcpy(napis,itoa_hex_word(ntohs(b_ethII.id)));
    pokaz_napis(59,3,napis,0);
    b_offset=&linie[linia].danepola;
    b_offset+=sizeof(struct ethernetII);
    switch (ntohs(b_ethII.id)) {
	// IP
	case 0x0800: 	memcpy(&b_ipv4,b_offset,sizeof(struct ramka_ipv4));
			strcpy(napis,"IP");
			pokaz_napis(4,5,napis,0);
			strcpy(napis,"Ver=");
			pokaz_napis(17,5,napis,0);
			pokaz_napis(21,5,itoa_hex_byte(b_ipv4.wersja_ihl),0);
			strcpy(napis,"ToS=");
			pokaz_napis(25,5,napis,0);
			pokaz_napis(29,5,itoa_bin_int(b_ipv4.tos,8),0);
			strcpy(napis,"Len=");
			pokaz_napis(39,5,napis,0);
			pokaz_napis(43,5,itoa_hex_word(ntohs(b_ipv4.dlugosccalkowita)),0);
	    		strcpy(napis,"ID=");
			pokaz_napis(49,5,napis,0);
			pokaz_napis(52,5,itoa_hex_word(ntohs(b_ipv4.id)),0);
			strcpy(napis,"Flags=");
			pokaz_napis(58,5,napis,0);
			strcpy(napis,itoa_bin_int(ntohs(b_ipv4.flagi_offset),16));
			napis[3]='\0';
			pokaz_napis(64,5,napis,0);
			strcpy(napis,"Offset=");
			pokaz_napis(17,6,napis,0);
			strcpy(napis,itoa_hex_word(ntohs(b_ipv4.flagi_offset))+1);
			pokaz_napis(24,6,napis,0);			
			strcpy(napis,"TTL=");
			pokaz_napis(29,6,napis,0);
			pokaz_napis(33,6,itoa_hex_byte(b_ipv4.ttl),0);			    
			strcpy(napis,"Protocol=");
			pokaz_napis(37,6,napis,0);
			pokaz_napis(46,6,itoa_hex_byte(b_ipv4.protokol),0);
			strcpy(napis,"CRC=");
			pokaz_napis(50,6,napis,0);
			pokaz_napis(54,6,itoa_hex_word(ntohs(b_ipv4.sumakontrolna)),0);						    
			strcpy(napis,"IPs=");
			pokaz_napis(17,7,napis,0);
			pokaz_napis(21,7,inet_ntoa(b_ipv4.ipzrodla),0);						    
			strcpy(napis,"IPd=");
			pokaz_napis(38,7,napis,0);
			pokaz_napis(42,7,inet_ntoa(b_ipv4.ipprzeznaczenia),0);
			b_offset+=sizeof(struct ramka_ipv4);
			switch (b_ipv4.protokol) {
			    // ICMP
			    case 0x01: 	memcpy(&b_pro_icmp,b_offset,sizeof(struct protokol_icmp));
					strcpy(napis,"ICMP");
					pokaz_napis(4,9,napis,0);
					strcpy(napis,"Type=");
					pokaz_napis(17,9,napis,0);
					pokaz_napis(22,9,itoa_hex_byte(b_pro_icmp.typ),0);
					strcpy(napis,"Code=");
					pokaz_napis(26,9,napis,0);
					pokaz_napis(31,9,itoa_hex_byte(b_pro_icmp.kod),0);
					strcpy(napis,"CRC=");
					pokaz_napis(35,9,napis,0);
					pokaz_napis(39,9,itoa_hex_word(b_pro_icmp.sumakontrolna),0);
					iledanychpakietu=(linie[linia].iledanych-sizeof(struct protokol_icmp)-sizeof(struct ramka_ipv4)-sizeof(struct ethernetII));
					if (iledanychpakietu>0) {
					    strcpy(napis," 'D'=view data ICMP |");
					    pokaz_napis(15,18,napis,0);
					    b2_offset=b_offset;
					    b2_offset+=sizeof(struct protokol_icmp);
					    memcpy(&danepakietu,b2_offset,iledanychpakietu);
					}
					break;
			    // TCP
			    case 0x06: 	memcpy(&b_pro_tcp,b_offset,sizeof(struct protokol_tcp));
					strcpy(napis,"TCP");
					pokaz_napis(4,9,napis,0);
					strcpy(napis,"Ports=");
					pokaz_napis(17,9,napis,0);
					pokaz_napis(23,9,itoa_hex_word(ntohs(b_pro_tcp.portzrodla)),0);
					strcpy(napis,"Portd=");
					pokaz_napis(29,9,napis,0);
					pokaz_napis(35,9,itoa_hex_word(ntohs(b_pro_tcp.portprzeznaczenia)),0);
					strcpy(napis,"Next number=");
					pokaz_napis(41,9,napis,0);
					pokaz_napis(53,9,itoa_hex_dword(ntohl(b_pro_tcp.numerkolejny)),0);
					strcpy(napis,"Akcept number=");
					pokaz_napis(17,10,napis,0);
					pokaz_napis(31,10,itoa_hex_dword(ntohl(b_pro_tcp.numerpotwierdzenia)),0);		
					strcpy(napis,"Offset=");
					pokaz_napis(41,10,napis,0);
					strcpy(napis,itoa_hex_word(ntohs(b_pro_tcp.offset_rezerwa_flagi)));
					napis[1]='\0';
					pokaz_napis(48,10,napis,0);
					strcpy(napis,"Flags=");
					pokaz_napis(51,10,napis,0);
					strcpy(napis,itoa_bin_int(ntohs(b_pro_tcp.offset_rezerwa_flagi),16)+10);
					pokaz_napis(57,10,napis,0);
					strcpy(napis,"Window=");
					pokaz_napis(17,11,napis,0);
					pokaz_napis(24,11,itoa_hex_word(ntohs(b_pro_tcp.okno)),0);															
					strcpy(napis,"CRC=");
					pokaz_napis(30,11,napis,0);
					pokaz_napis(34,11,itoa_hex_word(ntohs(b_pro_tcp.sumakontrolna)),0);															
					strcpy(napis,"Piority=");
					pokaz_napis(40,11,napis,0);
					pokaz_napis(48,11,itoa_hex_word(ntohs(b_pro_tcp.piorytet)),0);															
					iledanychpakietu=(linie[linia].iledanych-sizeof(struct protokol_tcp)-sizeof(struct ramka_ipv4)-sizeof(struct ethernetII));
					if (iledanychpakietu>0) {
					    strcpy(napis," 'D'=view data TCP |");
					    pokaz_napis(15,18,napis,0);
					    b2_offset=b_offset;
					    b2_offset+=sizeof(struct protokol_tcp);
					    memcpy(&danepakietu,b2_offset,iledanychpakietu);
					}
					break;
			    // UDP
			    case 0x11: 	memcpy(&b_pro_udp,b_offset,sizeof(struct protokol_udp));
					strcpy(napis,"UDP");
					pokaz_napis(4,9,napis,0);
					strcpy(napis,"Ports=");
					pokaz_napis(17,9,napis,0);
					pokaz_napis(23,9,itoa_hex_word(ntohs(b_pro_udp.portzrodlo)),0);
					strcpy(napis,"Portd=");
					pokaz_napis(29,9,napis,0);
					pokaz_napis(35,9,itoa_hex_word(ntohs(b_pro_udp.portprzeznaczenia)),0);
					strcpy(napis,"Len=");
					pokaz_napis(17,10,napis,0);
					pokaz_napis(21,10,itoa_hex_word(ntohs(b_pro_udp.dlugosc)),0);
					strcpy(napis,"CRC=");
					pokaz_napis(27,10,napis,0);
					pokaz_napis(31,10,itoa_hex_word(ntohs(b_pro_udp.sumakontrolna)),0);
					iledanychpakietu=(linie[linia].iledanych-sizeof(struct protokol_udp)-sizeof(struct ramka_ipv4)-sizeof(struct ethernetII));
					if (iledanychpakietu>0) {
					    strcpy(napis," 'D'=view data UDP |");
					    pokaz_napis(15,18,napis,0);
					    b2_offset=b_offset;
					    b2_offset+=sizeof(struct protokol_udp);
					    memcpy(&danepakietu,b2_offset,iledanychpakietu);
					}
					break;
			}
			break;
	// ARP
	case 0x0806: 	memcpy(&b_arp,b_offset,sizeof(struct ramka_arp));
			strcpy(napis,"ARP");
			pokaz_napis(4,5,napis,0);
			strcpy(napis,"Protocol Hardware=");
			pokaz_napis(17,5,napis,0);
			pokaz_napis(35,5,itoa_hex_word(ntohs(b_arp.protokolsprzetowy)),0);
			strcpy(napis,"Protocol Logic=");
			pokaz_napis(41,5,napis,0);
			pokaz_napis(56,5,itoa_hex_word(ntohs(b_arp.protokollogiczny)),0);
			strcpy(napis,"Len Hardware=");
			pokaz_napis(17,6,napis,0);
			pokaz_napis(30,6,itoa_hex_byte(b_arp.dlugoscadresusprzetowego),0);
			strcpy(napis,"Len Logic=");
			pokaz_napis(34,6,napis,0);
			pokaz_napis(44,6,itoa_hex_byte(b_arp.dlugoscadresulogicznego),0);
			strcpy(napis,"Code Proc=");
			pokaz_napis(48,6,napis,0);
			pokaz_napis(58,6,itoa_hex_word(ntohs(b_arp.kodoperacji)),0);
			strcpy(napis,"MACd=");
			pokaz_napis(17,7,napis,0);
			strcpy(napis,"");
			for (i=0;i<=5;i++) strcat(napis,itoa_hex_byte(b_arp.macprzeznaczenia[i]));
			pokaz_napis(22,7,napis,0);
			strcpy(napis,"IPd=");
			pokaz_napis(36,7,napis,0);
			pokaz_napis(40,7,itoa_ip(&b_arp.ipprzeznaczenia),0);
			strcpy(napis,"MACs=");
			pokaz_napis(17,8,napis,0);
			strcpy(napis,"");
			for (i=0;i<=5;i++) strcat(napis,itoa_hex_byte(b_arp.maczrodla[i]));
			pokaz_napis(22,8,napis,0);
			strcpy(napis,"IPs=");
			pokaz_napis(36,8,napis,0);
			pokaz_napis(40,8,itoa_ip(&b_arp.ipzrodla),0);
			iledanychpakietu=(linie[linia].iledanych-sizeof(struct ramka_arp)-sizeof(struct ethernetII));
			if (iledanychpakietu>0) {
			    strcpy(napis," 'D'=view data ARP |");
			    pokaz_napis(15,18,napis,0);
			    b2_offset=b_offset;
			    b2_offset+=sizeof(struct ramka_arp);
			    memcpy(&danepakietu,b2_offset,iledanychpakietu);
			}
			break;	
    }
    keypad(stdscr,TRUE);
    nodelay(stdscr,TRUE);
    do {
	klawisz=getch();
	if (klawisz=='D') podglad_danych_pakietu(4,2,20,&danepakietu,iledanychpakietu);
    } while (!(klawisz=='Q'));
    plik1=fopen(nplik1,"r");
    stdscr=getwin(plik1);
    fclose(plik1);
    remove(&nplik1);
    wrefresh(stdscr);
    return 0;
}
